// Auto-generated. Do not edit!

// (in-package compass_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Azimuth {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.azimuth = null;
      this.variance = null;
      this.unit = null;
      this.orientation = null;
      this.reference = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('azimuth')) {
        this.azimuth = initObj.azimuth
      }
      else {
        this.azimuth = 0.0;
      }
      if (initObj.hasOwnProperty('variance')) {
        this.variance = initObj.variance
      }
      else {
        this.variance = 0.0;
      }
      if (initObj.hasOwnProperty('unit')) {
        this.unit = initObj.unit
      }
      else {
        this.unit = 0;
      }
      if (initObj.hasOwnProperty('orientation')) {
        this.orientation = initObj.orientation
      }
      else {
        this.orientation = 0;
      }
      if (initObj.hasOwnProperty('reference')) {
        this.reference = initObj.reference
      }
      else {
        this.reference = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Azimuth
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [azimuth]
    bufferOffset = _serializer.float64(obj.azimuth, buffer, bufferOffset);
    // Serialize message field [variance]
    bufferOffset = _serializer.float64(obj.variance, buffer, bufferOffset);
    // Serialize message field [unit]
    bufferOffset = _serializer.uint8(obj.unit, buffer, bufferOffset);
    // Serialize message field [orientation]
    bufferOffset = _serializer.uint8(obj.orientation, buffer, bufferOffset);
    // Serialize message field [reference]
    bufferOffset = _serializer.uint8(obj.reference, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Azimuth
    let len;
    let data = new Azimuth(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [azimuth]
    data.azimuth = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [variance]
    data.variance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [unit]
    data.unit = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [orientation]
    data.orientation = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [reference]
    data.reference = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 19;
  }

  static datatype() {
    // Returns string type for a message object
    return 'compass_msgs/Azimuth';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3d29f65190522f1df8ce6297b7651854';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    Header header
    
    # The represented azimuth angle (angular difference between a given direction and north/east) in unit corresponding to
    # the 'unit' field.
    float64 azimuth
    
    # Variance of the measurement (i.e. standard deviation squared) in units corresponding to squared 'unit' field.
    float64 variance
    
    # Unit of measurement:
    #  RAD: radians, default
    #  DEG: degrees (not suggested by REP-103, but are more human-friendly)
    uint8 UNIT_RAD=0
    uint8 UNIT_DEG=1
    uint8 unit
    
    # Orientation type:
    #  ENU: default, 0 degrees on east, increases CCW, follows to REP-103
    #  NED: 0 degrees on north, increases CW (consistent with the touristic magnetic compasses)
    uint8 ORIENTATION_ENU=0
    uint8 ORIENTATION_NED=1
    uint8 orientation
    
    # Which north reference is used:
    #  MAGNETIC: magnetic north, changes in time
    #  GEOGRAPHIC: geographic north, stable in time, also called "true azimuth"
    #  UTM: UTM grid azimuth, based on GEOGRAPHIC, but accounts for UTM grid convergence; valid only in specific UTM zone
    uint8 REFERENCE_MAGNETIC=0
    uint8 REFERENCE_GEOGRAPHIC=1
    uint8 REFERENCE_UTM=2
    uint8 reference
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Azimuth(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.azimuth !== undefined) {
      resolved.azimuth = msg.azimuth;
    }
    else {
      resolved.azimuth = 0.0
    }

    if (msg.variance !== undefined) {
      resolved.variance = msg.variance;
    }
    else {
      resolved.variance = 0.0
    }

    if (msg.unit !== undefined) {
      resolved.unit = msg.unit;
    }
    else {
      resolved.unit = 0
    }

    if (msg.orientation !== undefined) {
      resolved.orientation = msg.orientation;
    }
    else {
      resolved.orientation = 0
    }

    if (msg.reference !== undefined) {
      resolved.reference = msg.reference;
    }
    else {
      resolved.reference = 0
    }

    return resolved;
    }
};

// Constants for message
Azimuth.Constants = {
  UNIT_RAD: 0,
  UNIT_DEG: 1,
  ORIENTATION_ENU: 0,
  ORIENTATION_NED: 1,
  REFERENCE_MAGNETIC: 0,
  REFERENCE_GEOGRAPHIC: 1,
  REFERENCE_UTM: 2,
}

module.exports = Azimuth;
